#include <iterator>

template<class T>
class DynArray {
    T* data;
    int count;
    int capacity;
public:
    class iterator;
    friend class iterator;
    typedef std::reverse_iterator<iterator> reverse_iterator;

    class iterator : public std::iterator<std::random_access_iterator, T> {
        friend class DynArray<T>;
        DynArray<T>* p;
        int pos;
        iterator(DynArray<T>* p, bool at_end = false) {
            this->p = p;
            pos = at_end ? p->count : 0;
        }
    public:
        T& operator*() {
            return p->data[pos];
        }
        iterator& operator++() {
            if (pos < p->count)
                ++pos;
            return *this;
        }
    };
    void push_back(const T& t);
    iterator begin() {
        return iterator(this);
    }
    iterator end() {
        return iterator(this, true);
    }
    reverse_iterator rbegin() {
        return reverse_iterator(end());
    }
    reverse_iterator rend() {
        return reverse_iterator(begin());
    }
};

template<class T>
void DynArray<T>::push_back(const T& t) {
}
