// Illustrates private inheritance

class Base
{
public:
   void f() {}
   void g() {}
};

class Derived : Base
{
public:
   using Base::f; // makes f public for clients (overrides private)
   void h()
   {
      f();  // Derived can access non-private
      g();  // members of Base as usual.
   }
};

int main()
{
   Derived d;
   d.h();   // okay
   d.g();   // error
   d.f();   // Now okay
}

/* Compiler output:
Error E2247 c:\uvsc\spring02\3370\private.cpp 25: 'Base::g()' is not accessible in function main()
*/


